from typing import List, Any


class QueueList:
    def __init__(self) -> None:
        self._list: List[Any] = []
        self._front: Any = None
        self._back: Any = None

    def __len__(self) -> int:
        return len(self._list)

    def __str__(self) -> str:
        return ",".join(self._list)

    @property
    def list(self) -> List[Any]:
        return self._list

    @property
    def front(self) -> Any:
        self._front = self._get_front(self)
        return self._front

    @property
    def back(self) -> Any:
        self._back = self._get_back(self)
        return self._back

    def enqueue(self, new_element: any) -> None:
        self._list.append(new_element)

    def dequeue(self) -> None:
        self._list = self._list[1:]

    def _get_front(self) -> Any:
        if len(self._list) == 0:
            return None

        return self._list[0]

    def _get_back(self) -> Any:
        if len(self._list) == 0:
            return None

        return self._list[-1]
