from typing import List, Any


class StackList:
    def __init__(self) -> None:
        self._list: List[Any] = []
        self._top: Any = None
        self._bottom: Any = None

    def __len__(self) -> int:
        return len(self._list)

    def __str__(self) -> str:
        return ",\n".join(self._list)

    @property
    def list(self) -> List[Any]:
        return self._list

    @property
    def top(self) -> Any:
        self._top = self._get_top(self)
        return self._top

    @property
    def bottom(self) -> Any:
        self._bottom = self._get_bottom(self)
        return self._bottom

    def push(self, new_element: any) -> None:
        self._list.append(new_element)

    def pop(self) -> None:
        self._list = self._list[:-1]

    def _get_top(self) -> Any:
        if len(self._list) == 0:
            return None

        return self._list[-1]

    def _get_bottom(self) -> Any:
        if len(self._list) == 0:
            return None

        return self._list[0]
